<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\works;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\works\GroupServiceWorkLists;
use app\adminapi\logic\works\GroupServiceWorkLogic;
use app\adminapi\validate\works\GroupServiceWorkValidate;
use app\common\model\master_worker\MasterWorkerTemporary;

/**
 * GroupServiceWork控制器
 * Class GroupServiceWorkController
 * @package app\adminapi\controller\works
 */
class GroupServiceWorkController extends BaseAdminController
{


    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function lists()
    {
        return $this->dataLists(new GroupServiceWorkLists());
    }

    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function edit()
    {
        $params = (new GroupServiceWorkValidate())->post()->goCheck('edit');
        $workDetail = GroupServiceWorkLogic::detail($params);
        
        $result = GroupServiceWorkLogic::edit($params);
        if (true === $result) {
            if(strtotime($workDetail['appointment_time']) !== strtotime($params['appointment_time']) && !empty($workDetail['master_worker_id'])){
                $masterDetail = MasterWorkerTemporary::where(['id'=>$workDetail['master_worker_id']])->findOrEmpty()->toArray();
                // 修改预约时间通知【给用户的通知】
                $res = event('Notice',  [
                    'scene_id' => 117,
                    'params' => [
                        'user_id' => $workDetail['user_id'],
                        'date' => $params['appointment_time'],
                        'tel' => asteriskString($masterDetail['mobile']),
                    ]
                ]);
                // 修改预约时间通知【给工程师的通知，仅限公众号】
                $res = event('Notice',  [
                    'scene_id' => 118,
                    'params' => [
                        'user_id' => $workDetail['master_worker_id'],
                        'order_id' => $workDetail['id'],
                        'thing4' => $workDetail['title'],
                        'time5' => $workDetail['appointment_time'],
                        'time6' => $params['appointment_time'],
                        'thing11' => (iconv_strlen($workDetail['address'])>15)?(mb_substr($workDetail['address'],0,15,'UTF-8').'...'):$workDetail['address'],
                        'phone_number8' => asteriskString($workDetail['mobile']),
                    ]
                ]);
            }
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(GroupServiceWorkLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function delete()
    {
        $params = (new GroupServiceWorkValidate())->post()->goCheck('delete');
        $result = GroupServiceWorkLogic::edit($params);
        if (true === $result) {
            return $this->success('删除成功', [], 1, 1);
        }
        return $this->fail(GroupServiceWorkLogic::getError());
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function detail()
    {
        $params = (new GroupServiceWorkValidate())->goCheck('detail');
        $result = GroupServiceWorkLogic::detail($params);
        return $this->data($result);
    }


    public function allocateWorker()
    {
        $params = (new GroupServiceWorkValidate())->post()->goCheck('allocateWorker');
        $result = GroupServiceWorkLogic::allocateWorker($params,$this->adminInfo);
        if (true === $result) {
            return $this->success('分配工程师成功', [], 1, 1);
        }
        return $this->fail(GroupServiceWorkLogic::getError());
    }

    public function cancelAllocation()
    {
        $params = (new GroupServiceWorkValidate())->post()->goCheck('allocateWorker');
        $result = GroupServiceWorkLogic::cancelAllocation($params,$this->adminInfo);
        if (true === $result) {
            return $this->success('操作成功！', [], 1, 1);
        }
        return $this->fail(GroupServiceWorkLogic::getError());
    }

    public function confirmServiceFinish()
    {
        $params = request()->post();
        $params['admin_id'] = $this->adminId;
      
        return $this->success('操作成功！', [], 1, 1);
    }

    /**
     * 导入excel
     */
    public function import()
    {
        $file = request()->file('file');
        $result = GroupServiceWorkLogic::import($file);
        if (true === $result) {
            return $this->success('导入成功', [], 1, 1);
        }
        return $this->fail(GroupServiceWorkLogic::getError());
    }
    
    /**
     * @notes 退款
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/07/10 15:06
     */
    public function refund()
    {
        $params = (new GroupServiceWorkValidate())->post()->goCheck('detail');
        $result = GroupServiceWorkLogic::refund($params,$this->adminInfo);
        if (true === $result) {
            return $this->success('退款成功', [], 1, 1);
        }
        return $this->fail(GroupServiceWorkLogic::getError());
    }
}